/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by  Advanced Data Controls, Corp
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2010      by GJ Designing Center Print Business Group
 *                             RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_timer.h,v 1.1 2010/02/07 18:14:24 roi Exp $
 */

/*
 *  CPU¸ޥ⥸塼mindstormsnxtѡ
 *  INT10
 */

#ifndef _HW_SYS_TIMER_H_
#define _HW_SYS_TIMER_H_

#include "mindstormsnxt.h"
#include "hw_serial.h"

typedef void * VP;

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define PIT_FREQ 1000		/* Hz */


#ifndef _MACRO_ONLY
/*
 *  ƥॿޤεưؿץȥ
 */
extern void InitHwSysTimer( void );

/*
 *  ƥॿޤ߽ؿץȥ
 */
extern void TermHwSysTimer( void );

/*
 *  ƥॿޤγ׵᥯ꥢ
 *
 *  ȯ˼ưŪ˥ꥢ뤬߰ʳ
 *  ¹Ԥ뤳Ȥꤷ롥
 */
static void
ClearHwSysTimerInt( void )
{
    unsigned long tmp = sil_rew_mem((VP)(TADR_PIT_BASE+TOFF_PIT_PIVR));
			/* ٥륿ޤγߵư */
	RxHwSerialCheck();		/* ǧ */
	sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_ISCR), (1 << IRQ_PWM_PID));
}	/* ClearHwSysTimerInt	*/

#endif /* _MACRO_ONLY */
#endif /* _HW_SYS_TIMER_H_ */

