/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *	ץåȰ¸⥸塼mindstorms-nxtѡ
 */


#include	"sample_config.h"
#include	"mindstormsnxt.h"

#define TADR_TC0_BASE   TADR_TC_BASE
#define TADR_TC2_BASE   (TADR_TC_BASE+TC_WINDOW*2)

/*
 *  ԥ󥳡ɤλ꤬ʤΥǥեȤ"1234"Ȥ
 */
#ifndef BLUETOOTH_PINCODE
#define BLUETOOTH_PINCODE       "1234"
#endif

/*
 *  OILܥγ
 */
DeclareCounter( SampleCnt );


/*
 *	ؿץȥ
 */
ISR( CounterInt );
ISR( HwCnt2Int );


/*
 *  ץꥱ⡼
 */
/*
 *  ץꥱ⡼ɷѤξ
 *
 *  ƥऴȤǤդϼˡˤ뤳ȡ
 *  0,1,2Ƚ̤Ǥ뤳ȡ32Ʊˤʤ롥
 *
 *  SWʤᡢȤꤢ1֤
 */
UINT8
GetAppModeInfo( void )
{
	return (UINT8)(1);
}	/* GetAppModeInfo	*/

/*
 *  ץ륫󥿥
 *
 *  mindstorms-nxtǤ϶ޤʤΤǤεǽϥݡȤʤ
 */
/*
 *  SignalCounter¹ѳ߽
 *
 *  ޤεư̴ؿǹԤ
 *  бΥޤʤᡢݡȤʤ
 */
void
InitCounterInt( void )
{
}	/* InitCounterInt	*/

/*
 *  SignalCounter¹ѳ߽
 *  бΥޤʤᡢݡȤʤ
 */
void
TermCounterInt( void )
{
}	/* TermCounterInt	*/

/*
 *  SignalCounter¹ѳߵư
 *  бΥޤʤᡢݡȤʤ
 */
void
ActCounterInt( void )
{
}	/* ActCounterInt	*/

/*
 *  SignalCounter¹ѳߥӥ롼
 *  бΥޤʤᡢݡȤʤ
 */
ISR( CounterInt )
{
	StatusType	ercd;

	/*
	 *  1Τ SignalCounter ¹Ԥᡤޤߤ롥
	 */

	/*
	 *  󥿲ûν¹
	 */
	ercd = SignalCounter( SampleCnt );
	/* 顼꥿ξϥåȥ	*/
	if(E_OK != ercd){
		ShutdownOS(ercd);
	}
}	/* ISR( CounterInt )	*/


/*
 *  ISR1ISR2ưǧ
 *
 *  mindstorm-nxtǤϥTc2,Tc0Ǽ롥
 */
/*
 *  ϡɥ󥿥Хåե
 */
static UINT8	hw_cnt1;
static UINT8	hw_cnt2;

/*
 *  ISR1ISR2󥿽
 */
void
InitHwCntInt( void )
{
	/*
	 *  ϡɥ󥿽
	 */
	hw_cnt1 = (UINT8)( 0 );
	hw_cnt2 = (UINT8)( 0 );

    /*  å֥͡ */
    sil_wrw_mem((VP)(TADR_PMC_BASE+TOFF_PMC_PCER), (1<<IRQ_TC0_PID));
    /*   */
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
    /*  ͤ򥻥å */
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_CMR), TC_CLKS_MCK8);	/* 47,923,200Hz/8=5,990,400Hz */
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_CMR), sil_rew_mem((VP)(TADR_TC0_BASE+TOFF_TC_CMR)) | TC_WAVESEL10);
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_RC), 59900);			/* 10ms */

    /*  å֥͡ */
    sil_wrw_mem((VP)(TADR_PMC_BASE+TOFF_PMC_PCER), (1<<IRQ_TC2_PID));
    /*   */
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
    /*  ͤ򥻥å */
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_CMR), TC_CLKS_MCK8);	/* 47,923,200Hz/8=5,990,400Hz */
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_CMR), sil_rew_mem((VP)(TADR_TC2_BASE+TOFF_TC_CMR)) | TC_WAVESEL10);
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_RC), 59900);			/* 10ms */

    /*  ȥ   */
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_CCR), (TC_CLKEN|TC_SWTRG));
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_IER), TC_CPCS);
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_CCR), (TC_CLKEN|TC_SWTRG));
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_IER), TC_CPCS);
}	/* InitHwCntInt	*/

/*
 *  ISR1ISR2߽
 */
void
TermHwCntInt( void )
{
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((VP)(TADR_TC0_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_CCR), TC_CLKDIS);
    sil_wrw_mem((VP)(TADR_TC2_BASE+TOFF_TC_IDR), 0xFFFFFFFF);
}	/* TermHwCntInt	*/

/*
 *  ISR1ISR2󥿼
 *
 *  hw_cnt1hw_cnt2Ʊݾ㤷ʤƤ褤ʳ߶ػߤסˡ
 */
void
GetHwCnt( UINT8 *isr1_cnt, UINT8 *isr2_cnt )
{
	*isr1_cnt = hw_cnt1;
	*isr2_cnt = hw_cnt2;
}	/* GetHwCnt	*/

/*
 *  ISR1󥿲ûѳߥӥ롼
 */
void
HwCnt1Int( void )
{
    sil_rew_mem((VP)(TADR_TC2_BASE+TOFF_TC_SR));
	hw_cnt1++;
}	/* HwCnt1Int	*/

/*
 *  ISR2󥿲ûѳߥӥ롼
 */
ISR( Tc0Int )	/* HwCnt2Int */
{
    sil_rew_mem((VP)(TADR_TC0_BASE+TOFF_TC_SR));
	hw_cnt2++;
}	/* ISR( HwCnt2Int )	*/


UINT8 *bluetooth_get_pincode(void)
{
	return (UINT8 *)BLUETOOTH_PINCODE;
}

/* Originally, systick_low_priority_C is a LEJOS ISR. 
 * LEJOS-OSEK uses systick_isr_C1 category 2 ISR instead of systick_low_priority_C 
 * to implement a system timer module for OSEK alarm and 
 * check the buttons status to shutdown the system
 */

ISR( UserTimerInt )
{
	static int mtimer = 0;
	/* clear the interrupt status register (2007/12/27) */
	sil_wrw_mem((VP)(TADR_AIC_BASE+TOFF_AIC_ICCR), 1<<10);

	/* check OSEK was started */ 
	if((mtimer % 4) == 0){
		if(mtimer >= 12){
			check_NXT_buttons(0);
			mtimer = 0;
		}
	}
	mtimer++;

	/* this function should be here to stop the NXT immediately 
	 * after EXIT button was pressed
	 */
	rtos_1kHz_process(0);
}

